"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addPackageJSONIfNeeded = exports.createPackageJSON = void 0;
function createPackageJSON(dependencies, entry) {
    if (dependencies === void 0) { dependencies = {}; }
    if (entry === void 0) { entry = '/index.js'; }
    return JSON.stringify({
        name: 'sandpack-project',
        main: entry,
        dependencies: dependencies,
    }, null, 2);
}
exports.createPackageJSON = createPackageJSON;
function addPackageJSONIfNeeded(files, dependencies, entry) {
    var newFiles = __assign({}, files);
    if (!newFiles['/package.json']) {
        if (!dependencies) {
            throw new Error('No dependencies specified, please specify either a package.json or dependencies.');
        }
        if (!entry) {
            throw new Error("Missing 'entry' parameter. Either specify an entry point, or pass in a package.json with the 'main' field set.");
        }
        newFiles['/package.json'] = {
            code: createPackageJSON(dependencies, entry),
        };
    }
    return newFiles;
}
exports.addPackageJSONIfNeeded = addPackageJSONIfNeeded;
//# sourceMappingURL=utils.js.map