import AsyncMirror from '../backend/AsyncMirror';
import BundledHTTPRequest from '../backend/BundledHTTPRequest';
import CodeSandboxEditorFS from '../backend/CodeSandboxEditorFS';
import CodeSandboxFS from '../backend/CodeSandboxFS';
import DynamicHTTPRequest from '../backend/DynamicHTTPRequest';
import FolderAdapter from '../backend/FolderAdapter';
import HTTPRequest from '../backend/HTTPRequest';
import IndexedDB from '../backend/IndexedDB';
import InMemory from '../backend/InMemory';
import LocalStorage from '../backend/LocalStorage';
import MountableFileSystem from '../backend/MountableFileSystem';
import OverlayFS from '../backend/OverlayFS';
import UNPKGRequest from '../backend/UNPKGRequest';
import JSDelivrRequest from '../backend/JSDelivrRequest';
import WebsocketFS from '../backend/WebsocketFS';
import WorkerFS from '../backend/WorkerFS';
import ZipFS from '../backend/ZipFS';
/**
 * @hidden
 */
declare const Backends: {
    AsyncMirror: typeof AsyncMirror;
    FolderAdapter: typeof FolderAdapter;
    InMemory: typeof InMemory;
    IndexedDB: typeof IndexedDB;
    OverlayFS: typeof OverlayFS;
    LocalStorage: typeof LocalStorage;
    MountableFileSystem: typeof MountableFileSystem;
    WorkerFS: typeof WorkerFS;
    BundledHTTPRequest: typeof BundledHTTPRequest;
    HTTPRequest: typeof HTTPRequest;
    UNPKGRequest: typeof UNPKGRequest;
    JSDelivrRequest: typeof JSDelivrRequest;
    XmlHttpRequest: typeof HTTPRequest;
    ZipFS: typeof ZipFS;
    CodeSandboxFS: typeof CodeSandboxFS;
    CodeSandboxEditorFS: typeof CodeSandboxEditorFS;
    WebsocketFS: typeof WebsocketFS;
    DynamicHTTPRequest: typeof DynamicHTTPRequest;
};
export default Backends;
